      SUBROUTINE CALC1
C The factor SQRT(PI/2) to make weights compatible with earlier OMNEC
      INCLUDE 'prec.inc'
      PARAMETER (OMNFAC=1.253313)
      INCLUDE 'header.inc'
      INCLUDE 'cntrl.inc'
      INCLUDE 'data.inc'
      INCLUDE 'dataj.inc'
      CHARACTER*2 AIN,AINJ
      CHARACTER*6 PNET
      INCLUDE 'vsorc.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'matpar.inc'
      INCLUDE 'crnt.inc'
      INCLUDE 'netcx.inc'
      INCLUDE 'fpat.inc'
      INCLUDE 'zload.inc'
      common/globtim/totsec,timstrt
      DIMENSION  IP(2*NM),PNET(6)
      DIMENSION ZCM(NM*NM)
      DIMENSION  T1X(1), T1Y(1), T1Z(1), T2X(1), T2Y(1), T2Z(1)
      EQUIVALENCE (T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),
     &(T2Y,ICON2),(T2Z,ITAG)
      DATA PNET(1)/6H      /
      DATA PNET(2)/2H  /
      DATA PNET(3)/6HSTRAIG/
      DATA PNET(4)/2HHT/
      DATA PNET(5)/6HCROSSE/
      DATA PNET(6)/1HD/
C     SET UP GEOMETRY DATA IN SUBROUTINE DATAGN
C      I=KEYBD(0)
      I=0
      IF(I.EQ.0)GOTO 4
      WRITE(*,*)'Interrupted from keyboard'
      STOP
    4 IMAT=0
      CALL DATAGN
    6 NPEQ= NP
C
C     DEFAULT VALUES FOR INPUT PARAMETERS AND FLAGS
C
C***
      NFRQ=1
      IFRQ=1
      DELFRQ=0

      RKH=1
      IEXK=0
      NONET=0
C NLOAD  The number of loads
      NLOAD=0
      NONET=0
C NSANT,NVQD  Excitation flag, number of sources.
      NSANT=0
      NVQD=0
      NZSNOM=0
      NZVNOM=0
      NZTNOM=0
      FBEGIN= CVEL

C***
   14 CALL READMN(AIN,ITMP1,ITMP2,ITMP3,ITMP4,TMP1,TMP2,TMP3,
     &TMP4,TMP5,TMP6,5)
      IF(IOUT.EQ.0)WRITE(26,2492)AIN,ITMP1,ITMP2,ITMP3,ITMP4,TMP1,
     & TMP2,TMP3,TMP4,TMP5,TMP6
 2492 FORMAT(A2,I3,2I5,I4,' ',E11.5,4F10.4,F9.4)
      IF( AIN.EQ.'FR') GOTO 16
      IF( AIN.EQ.'LD') GOTO 17
      IF( AIN.EQ.'GN') GOTO 705
      IF( AIN.EQ.'EX') GOTO 24
      IF( AIN.EQ.'NT') GOTO 28
      IF( AIN.EQ.'TL') GOTO 28
      IF( AIN.EQ.'PT') GOTO 705
      IF( AIN.EQ.'PQ') GOTO 705
      IF( AIN.EQ.'XQ') GOTO 705
      IF( AIN.EQ.'NE') GOTO 705
      IF( AIN.EQ.'NH') GOTO 705
      IF( AIN.EQ.'GD') GOTO 705
      IF( AIN.EQ.'RP') GOTO 36
      IF( AIN.EQ.'KH') GOTO 305
      IF( AIN.EQ.'EK') GOTO 320
      IF( AIN.EQ.'NX') GOTO 705
      IF( AIN.EQ.'WG') GOTO 705
      IF( AIN.EQ.'PL') GOTO 705
      IF( AIN.EQ.'EN') GOTO 9010
      IF( AIN.EQ.'CP') GOTO 705


   15 WRITE(*,138)AIN
  138 FORMAT('FAULTY DATA CARD *',A2,'*')
      STOP
C     FREQUENCY PARAMETERS
   16 IFRQ= ITMP1
    8 NFRQ= ITMP2
      IF( NFRQ.EQ.0) NFRQ=1
      FBEGIN= TMP1
      DELFRQ= TMP2
C
C     MATRIX INTEGRATION LIMIT
C
      GOTO 14
  305 RKH= TMP1
C
C     EXTENDED THIN WIRE KERNEL OPTION
C And back lobe weight factor
      BCKWEI= TMP2*OMNFAC

      GOTO 14
  320 IEXK=1
      IF( ITMP1.EQ.-1) IEXK=0
      GOTO 14
C     LOADING PARAMETERS
   17 NLOAD= NLOAD+1
      IF( NLOAD.LE. LOADMX) GOTO 19
      WRITE(*,*)'TOO MANY LOADING CARDS'
      STOP
   19 LDTYP( NLOAD)= ITMP1
      LDTAG( NLOAD)= ITMP2
      IF( ITMP4.EQ.0) ITMP4= ITMP3
      LDTAGF( NLOAD)= ITMP3
      LDTAGT( NLOAD)= ITMP4
      IF( ITMP4.GE. ITMP3) GOTO 20
      WRITE(*,140)  NLOAD, ITMP3, ITMP4
  140 FORMAT(' DATA FAULT ON LOADING CARD NO.=',I5,/,'ITAG S',
     &'TEP1=',I5,'  IS GREATER THAN ITAG STEP2=',I5)
      STOP
   20 RZLR( NLOAD)= TMP1
      RZLI( NLOAD)= TMP2
      RZLC( NLOAD)= TMP3
      GOTO 14

C     EXCITATION PARAMETERS
   24 CONTINUE
      CALL READMN(AINJ,JTMP1,JTMP2,JTMP3,JTMP4,UMP1,UMP2,UMP3,
     &UMP4,UMP5,UMP6,7)
      IF( AINJ.NE.'EX') GOTO 2499
      IF( ITMP1.NE.JTMP1)GOTO 2499
      IF( ITMP2.NE.JTMP2)GOTO 2499
      IF( ITMP1.EQ.0) GOTO 205
      IF( ITMP1.NE.5) GOTO 27
      NVQD= NVQD+1
      IF( NVQD.GT. NVMAX) GOTO 206
      IVQD( NVQD)= ISEGNO( ITMP2, ITMP3)
      ZVQD( NVQD)= CMPLX( TMP1, TMP2)
      IF( ABS( ZVQD( NVQD)).LT.1.D-20) ZVQD( NVQD)=(1.,0.)
      IF(UMP3.LT.1.E-12)GOTO 14
      NZSNOM=NZSNOM+1
      IZSNOM(NZSNOM)=NVQD
      RZSNOM(NZSNOM,1)=UMP1
      RZSNOM(NZSNOM,2)=UMP2
      WEIZS(NZSNOM)=UMP3*OMNFAC
      GOTO 14
  205 NSANT= NSANT+1
      IF( NSANT.LE. NVMAX) GOTO 26
  206 WRITE(*,*)' TOO MANY EXCITATION CARDS'
      STOP
   26 ISANT( NSANT)= ISEGNO( ITMP2, ITMP3)
      ZVSNT( NSANT)= CMPLX( TMP1, TMP2)
      IF( ABS( ZVSNT( NSANT)).LT.1.D-20) ZVSNT( NSANT)=(1.,0.)
      IF(UMP3.LT.1.E-12)GOTO 14
      NZVNOM=NZVNOM+1
      IZVNOM(NZVNOM)=NSANT
      RZVNOM(NZVNOM,1)=UMP1
      RZVNOM(NZVNOM,2)=UMP2
      WEIZV(NZVNOM)=UMP3*OMNFAC
      GOTO 14
 2499 WRITE(26,2492)AIN,ITMP1,ITMP2,ITMP3,ITMP4,TMP1,
     & TMP2,TMP3,TMP4,TMP5,TMP6
      WRITE(*,2490)AINJ,JTMP1,JTMP2,JTMP3,JTMP4,UMP1,UMP2,UMP3,
     &UMP4, UMP5, UMP6
 2490 FORMAT(' ',A2,I3,3I5,6F9.4,/,' ERROR IN PARNR.NEC')
      STOP
   27 WRITE(*,*)'EXCITATION MODE NOT SUPPORTED'
      STOP
C
C     NETWORK PARAMETERS
   28 CALL READMN(AINJ,JTMP1,JTMP2,JTMP3,JTMP4,UMP1,UMP2,UMP3,
     &UMP4,UMP5,UMP6,7)
      IF( AINJ.NE.'TL'.AND.AINJ.NE.'NT') GOTO 2499
      IF( ITMP1.NE.JTMP1)GOTO 2499
      IF( ITMP2.NE.JTMP2)GOTO 2499
      IF( ITMP3.NE.JTMP3)GOTO 2499
      IF( ITMP4.NE.JTMP4)GOTO 2499
      NONET= NONET+1
      IF( NONET.LE. NETMX) GOTO 30
      WRITE(*,*)'TOO MANY NETWORK CARDS'
      STOP
   30 NTYP( NONET)=2
      IF( AIN.EQ.'NT') NTYP( NONET)=1
      ISEG1( NONET)= ISEGNO( ITMP1, ITMP2)
      ISEG2( NONET)= ISEGNO( ITMP3, ITMP4)
      X11R( NONET)= TMP1
      X11I( NONET)= TMP2
      X12R( NONET)= TMP3
      X12I( NONET)= TMP4
      X22R( NONET)= TMP5
      X22I( NONET)= TMP6
      IF( NTYP( NONET).EQ.1.OR. TMP1.GT.0.) GOTO 7014
      NTYP( NONET)=3
      X11R( NONET)=- TMP1
 7014 IF(UMP3.LT.1.E-12)GOTO 7016
      NZTNOM=NZTNOM+1
      IF(NZTNOM.GT.NVMAX)GOTO 7018
      IZTNOM(NZTNOM)= ISEGNO( ITMP1, ITMP2)
      RZTNOM(NZTNOM,1)=UMP1
      RZTNOM(NZTNOM,2)=UMP2
      WEIZT(NZTNOM)=UMP3*OMNFAC
 7016 IF(UMP6.LT.1.E-12)GOTO 14
      NZTNOM=NZTNOM+1
      IF(NZTNOM.GT.NVMAX)GOTO 7018
      IZTNOM(NZTNOM)= ISEGNO( ITMP3, ITMP4)
      RZTNOM(NZTNOM,1)=UMP4
      RZTNOM(NZTNOM,2)=UMP5
      WEIZT(NZTNOM)=UMP6*OMNFAC
      GOTO 14
 7018 WRITE(*,*)'Too many impedances to optimise (NT/TL options)'
      STOP




C Start optimisation when the *RP* card is encountered.
   36 CONTINUE



      IF(IOUT.EQ.1)GOTO 209
      IOUT=1
      WRITE(26,2492)'EN'
      CLOSE (26)
 209  CONTINUE
      NPPRT=0
      IF(NPAR.EQ.0.AND.NIT.EQ.0)NPPRT=ITMP1
      NTH= ITMP2
      NPH= ITMP3
      IF( NTH.EQ.0) NTH=1
      IF( NPH.EQ.0) NPH=1
      THETS= TMP1
      IF(THETS.EQ.0)THETS=360
      PHIS= TMP2
      GTWEI= TMP3*OMNFAC
      EFFWEI=TMP4*OMNFAC
      TSKY=TMP5
      TGND=TMP6
      IF(TSKY.LT.0)TSKY=0
      IF(TGND.LT.0)TGND=0
      IF(TSKY.EQ.0.AND.TGND.EQ.0)THEN
        IF(FBEGIN.LT.200)THEN
        TSKY=200
        TGND=1000
        ELSE
        TSKY=15
        TGND=290
        ENDIF
      ENDIF
C     CORE ALLOCATION FOR PRIMARY INTERACTON MATRIX.
      IF( IFRQ.EQ.1) GOTO 43
      FMHZ= FBEGIN + NOWFRQ*DELFRQ
      GOTO 44
   43 FMHZ= FBEGIN * DELFRQ**NOWFRQ
   44 FR= FMHZ/ CVEL
      WLAMV= CVEL/ FMHZ
      IF(ABS( (WLAM-WLAMV)/WLAM ).LT.1.E-6 )GOTO 2314
      WRITE(*,*)'FREQUENCIES DIFFERENT IN INPUT.NEC AND PARNR.NEC'
      STOP
 2314 CONTINUE
      IF(NIT.NE.0.OR.NPAR.NE.0)GOTO 2323
      IF(IRADCO.EQ.0)THEN
      WRITE(*,*)'-OMNEC- Vers 1.21    Model:Original NEC2.'
      ELSE
      WRITE(*,*)'-OMNEC- Vers 1.21    Model:Modified NEC2.'
      ENDIF
      IF(NZSNOM.GT.0)
     & WRITE(*,*)'Weights for Z(STEP):',(WEIZS(J)/OMNFAC,J=1,NZSNOM)
      IF(NZVNOM.GT.0)
     & WRITE(*,*)'Weights for Z(VOLTAGE):',(WEIZV(J)/OMNFAC,J=1,NZVNOM)
      IF(EFFWEI.NE.0)
     & WRITE(*,*)'Weight for EFFICIENCY:',EFFWEI/OMNFAC
      IF(BCKWEI.NE.0)
     & WRITE(*,*)'Weight for BACK LOBE:',BCKWEI/OMNFAC
      WRITE(*,144)GTWEI/OMNFAC,TGND,TSKY
 144  FORMAT('Weight for G/T enhancement:',F10.7,'      T(gnd)=',F7.1,
     &  ' T(sky)=',F6.1)
      WRITE(*,145)  FMHZ, WLAM
  145 FORMAT(' Frequency=',F10.4,' MHz   Wavelength=',F10.4,' METERS')
 2323 CONTINUE
      IF(NGEOM.EQ.0)WRITE(10,196)  RKH
  196 FORMAT(//,' APPROXIMATE INTEGRATION FOR SEGMENTS MORE THAN',
     &F8.3,' WAVELENGTHS APART')
      IF(NGEOM.EQ.0.AND.IEXK.EQ.1) WRITE(10,*)
     &'EXTENDED THIN WIRE KERNEL USED'
C     FREQUENCY SCALING OF GEOMETRIC PARAMETERS
      DO 45  I=1, N
      X( I)= X( I)* FR
      Y( I)= Y( I)* FR
      RXZ( I)= RXZ( I)* FR
      SI( I)= SI( I)* FR
      BI0(I)=BI0(I)*FR
   45 BI( I)= BI( I)* FR
C     STRUCTURE SEGMENT LOADING
   46 IF(NGEOM.EQ.0)WRITE(10,146)
  146 FORMAT(/,10X,' - - - STRUCTURE IMPEDANCE LOADING - - -')
      IF( NLOAD.NE.0) CALL LOAD
      IF(NGEOM.NE.0)GOTO 4422
      IF(NLOAD.EQ.0) WRITE(10,147)
  147 FORMAT(/,25X,'THIS STRUCTURE IS NOT LOADED')
 4422 CONTINUE
      IF( IMAT.EQ.0) CALL FBLOCK( NPEQ, N, IPSYM)
      CALL CMSET( N, ZCM)
      CALL FACTRS( NPEQ, N, ZCM, IP)
      NPRINT=0

C
C     MATRIX SOLVING  (NETWK CALLS SOLVES)
      CALL ETMNS(ZCUR)
      IF( NONET.EQ.0) GOTO 60
      IF( NGEOM.EQ.0)WRITE(10,158)
  158 FORMAT(//,24X,'- - - NETWORK DATA - - -')
      ITMP3=0
      ITMP1= NTYP(1)
      DO 59  I=1,2
      IF( ITMP1.EQ.3) ITMP1=2
      IF(NGEOM.EQ.0.AND.ITMP1.EQ.2) WRITE(10,159)
  159 FORMAT(/,6X,'- FROM -    - TO -',11X,'TRANSMISSION LINE',15X,
     &'-  -  SHUNT ADMITTANCES (MHOS)  -  -',14X,'LINE',/,6X,
     &'TAG  SEG.','   TAG  SEG.',6X,'IMPEDANCE',6X,'LENGTH',12X,
     &'- END ONE -',17X,'- END TWO -',12X,'TYPE',/,6X,
     &'NO.   NO.   NO.   NO.',9X,'OHM''S',8X,'METERS',9X,'REAL',10X,
     &'IMAG.',9X,'REAL',10X,'IMAG.')
      IF(NGEOM.EQ.0.AND.ITMP1.EQ.1) WRITE(10,160)
  160 FORMAT(/,6X,'- FROM -',4X,'- TO -',26X,'-  -  ADMITTANCE MATRIX',
     &' ELEMENTS (MHOS)  -  -',/,6X,'TAG  SEG.   TAG  SEG.',13X,'(ON',
     &'E,ONE)',19X,'(ONE,TWO)',19X,'(TWO,TWO)',/,6X,'NO.   NO.   NO.',
     &'   NO.',8X,'REAL',10X,'IMAG.',9X,'REAL',10X,'IMAG.',9X,'REAL',10
     &X,'IMAG.')
      DO 58  J=1, NONET
      ITMP2= NTYP( J)
      IF(( ITMP2/ ITMP1).EQ.1) GOTO 57
      ITMP3= ITMP2
      GOTO 58
   57 ITMP4= ISEG1( J)
      ITMP5= ISEG2( J)
      IF( ITMP2.GE.2.AND. X11I( J).LE.0.) X11I( J)= WLAM* SQRT(( X(
     &ITMP5)- X(ITMP4))**2+(Y(ITMP5)-Y(ITMP4))**2+(RXZ(ITMP5)-RXZ(
     &ITMP4))**2)
      IF(NGEOM.EQ.0)WRITE(10,157)ITAG(ITMP4),ITMP4,ITAG(ITMP5),ITMP5,
     & X11R(J),X11I(J),X12R(J),X12I(J),X22R(J),X22I(J),PNET(2*ITMP2-1)
     &, PNET(2*ITMP2)
  157 FORMAT(4X,4(I5,1X),1P,6(3X,E11.4),3X,A6,A2)
   58 CONTINUE
      IF( ITMP3.EQ.0) GOTO 60
      ITMP1= ITMP3
   59 CONTINUE
   60 CONTINUE
      CALL NETWK( ZCM, IP, ZCUR)
      IF( N.EQ.0) GOTO 308
   63 PLOSS=0.
      ITMP1=0
      DO 69  I=1, N
      ZCURI= ZCUR( I)* WLAM
      CMAG= ABS( ZCURI)
      IF( NLOAD.EQ.0) GOTO 69
      IF( ABS( DBLE( ZARRAY( I))).LT.1.D-20) GOTO 69
      PLOSS= PLOSS+.5* CMAG* CMAG* DBLE( ZARRAY( I))* SI( I)
      IF(I.NE.IILOAD)GOTO 69
      RESPWR=.5* CMAG* CMAG* DBLE( ZARRAY( I))* SI( I)
   69 CONTINUE
  308 TMP1= PIN- PNLS- PLOSS
      EFFIC=100.* TMP1/ PIN
      IF(NGEOM.NE.0)GOTO 1169
      WRITE(10,166)  PIN, TMP1, PLOSS, PNLS, EFFIC,RESPWR
  166 FORMAT(///13X,'INPUT POWER   =',1P,E11.4,' WATTS',
     &/,13X,'RADIATED POWER=',E11.4,' WATTS',
     &/,13X,'STRUCTURE LOSS=',E11.4,' WATTS',
     &/,13X,'NETWORK LOSS  =',E11.4,' WATTS',
     &/,13X,'EFFICIENCY    =',0P,F7.2,' PERCENT'
     &/,13X,'PART OF STRUCTURE LOSS IN RESISTOR',E11.4,' WATTS')
 1169 IF(NIT.GT.1.OR.NPAR.GT.0)GOTO 70
      IHR=0
      IMIN=0
      ISEC=0
      I100TH=0
      call ztim
      WRITE(*,629)totsec-timstrt
 629  FORMAT(' TOTAL TIME=',F8.2,' sek')
   70 CONTINUE
      PINR= PIN
      PNLR= PNLS
      CALL RDPAT
      GOTO 14
C
C
 705  WRITE(*,*)'Option not supported:',AIN
      STOP
 9010 CONTINUE

      RETURN
      END
