      SUBROUTINE LOAD
C
C     LOAD CALCULATES THE IMPEDANCE OF SPECIFIED SEGMENTS FOR VARIOUS
C     TYPES OF LOADING
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      INCLUDE 'cntrl.inc'
      INCLUDE 'zload.inc'
      DIMENSION TPCJX(2),XTM(2)
      EQUIVALENCE(ZTPCJ,TPCJX) ,(ZTM,XTM(1))
      DATA   TPCJX/0.,1.883698955D+9/
      DO 1  I= 1, N
    1 ZARRAY( I)=(0.,0.)
      IILOAD=0
C
C     CYCLE OVER LOADING CARDS
C

      IWARN=0
      ISTEP=0
    2 ISTEP= ISTEP+1
      IF( ISTEP.LE. NLOAD) GOTO 5
      IF( IWARN.EQ.0)GOTO 26
      WRITE(*,*)'SOME SEGMENTS HAVE BEEN LOADED TWICE'
      WRITE(*,*)'See file GEOMETRY.NEC'
      STOP
   26 CONTINUE
      IF(IILOAD.GT.0)WRITE(*,*)
     &'SINGLE LOAD RESISTOR FOUND WITH LDTYP=0 AT ITAG=',IILOAD
      RETURN
    5 IF( LDTYP( ISTEP).LE.5) GOTO 6
      WRITE(*,27)  LDTYP( ISTEP)
   27 FORMAT(/,' IMPROPER LOAD TYPE CHOOSEN, REQUESTED TYPE IS ',I3)
      STOP
    6 LDTAGS= LDTAG( ISTEP)
      JUMP= LDTYP( ISTEP)+1
C
C     SEARCH SEGMENTS FOR PROPER ITAGS
C
      ICHK=0
      L1= 1
      L2= N
      IF( LDTAGS.NE.0) GOTO 7
      IF( LDTAGF( ISTEP).EQ.0.AND. LDTAGT( ISTEP).EQ.0) GOTO 7
      L1= LDTAGF( ISTEP)
      L2= LDTAGT( ISTEP)
    7 DO 17  I= L1, L2
      IF( LDTAGS.EQ.0) GOTO 8
      IF( LDTAGS.NE. ITAG( I)) GOTO 17
      IF( LDTAGF( ISTEP).EQ.0) GOTO 8
      ICHK= ICHK+1
      IF( ICHK.GE. LDTAGF( ISTEP).AND. ICHK.LE. LDTAGT( ISTEP)) GOTO 9
      GOTO 17
C
C     CALCULATION OF LAMDA*IMPED. PER UNIT LENGTH, JUMP TO APPROPRIATE
C     SECTION FOR LOADING TYPE
C
    8 ICHK=1
    9 CONTINUE
      GOTO (10,11,12,13,14,15), JUMP
   10 IF(IILOAD.NE.0)IILOAD=-1
      IF(IILOAD.EQ.0)IILOAD=I
      ZT= RZLR( ISTEP)/ SI( I)+ ZTPCJ* RZLI(ISTEP)/( SI( I)* WLAM)
      IF(ABS(RZLC(ISTEP)).GT.1.D-20)ZT=ZT+WLAM/(ZTPCJ*SI(I)*RZLC
     &( ISTEP))
      GOTO 16
   11 ZT= ZTPCJ* SI( I)* RZLC( ISTEP)/ WLAM
      IF(ABS(RZLI(ISTEP)).GT.1.D-20)ZT=ZT+SI(I)*WLAM/(ZTPCJ*RZLI
     &( ISTEP))
      IF( ABS( RZLR( ISTEP)).GT.1.D-20) ZT= ZT+ SI( I)/ RZLR( ISTEP)
      ZT=1./ ZT
      GOTO 16
   12 ZT= RZLR( ISTEP)* WLAM+ ZTPCJ* RZLI( ISTEP)
      IF(ABS(RZLC(ISTEP)).GT.1.D-20) ZT=ZT+1./(ZTPCJ*SI(I)*SI(I)
     &* RZLC( ISTEP))
      GOTO 16
   13 ZT= ZTPCJ* SI( I)* SI( I)* RZLC( ISTEP)
      IF(ABS(RZLI(ISTEP)).GT.1.D-20)ZT=ZT+1./( ZTPCJ* RZLI( ISTEP))
      IF(ABS(RZLR(ISTEP)).GT.1.D-20)ZT=ZT+1./( RZLR( ISTEP)* WLAM)
      ZT=1./ ZT
      GOTO 16
   14 ZT= CMPLX( RZLR( ISTEP), RZLI( ISTEP))/ SI( I)
      GOTO 16
   15 ZT= ZINT( RZLR( ISTEP)* WLAM, BI0(I))
   16 ZTM=ZARRAY(I)
      IF((ABS(XTM(1))+ABS(XTM(2))).GT.1.D-20
     &) IWARN=1
      ZARRAY( I)= ZARRAY( I)+ ZT
   17 CONTINUE
      IF( ICHK.NE.0) GOTO 2
      WRITE(*,28)  LDTAGS
   28 FORMAT(/,' LOADING DATA CARD ERROR, NO SEGMENT HAS AN ITAG =',
     &I5)
      STOP
      END
